package org.simantics.scl.reflection.internal.registry;

import org.osgi.framework.Bundle;

public class ExternalClass {
    public final Bundle bundle;
    public final String className;
    public final String alternativeName;
    
    public ExternalClass(Bundle bundle, String className, String alternativeName) {
        this.bundle = bundle;
        this.className = className;
        this.alternativeName = alternativeName;
    }

    public Class<?> loadClass() {
        try {
            return bundle.loadClass(className);
        } catch (ClassNotFoundException e) {
            return null;
        }   
    }    
}
